-- TEA Tiny Encryption Algorithm
-- Direct Euphoria attempt
-- Include Library (under construction)
-- initial attempt believing shifts are easy!

--with trace

constant NROUNDS = 32
constant t32 = power(2,32)

printf(1,"ETEA with %d rounds\n",{NROUNDS})

global function mod(object x, atom y)
atom xr
    while x < 0 do
      x += y
    end while
    xr = floor(remainder(x,y))
    return xr
end function

global function shift_r(atom x, atom n, atom m)
-- shift right mod m
  atom xs
  while x < 0 do
    x += m
  end while
  xs = mod(x / power(2,n),m)
  return xs
end function

global function shift_l(atom x, atom n, atom m)
-- shift left mod m
  atom xs
  while x < 0 do
    x += m
  end while
  xs = mod(x * power(2,n),m)
  return xs
end function

global function t_encrypt(sequence v, sequence k)
-- v asssumed to be two 32 bit unsigned numbers
-- k assumed to be four 32 bit unsigned numbers
-- will return w, sequence of two 32 bit unsigned numbers
atom sum, delta, n
atom y, z
atom p1,p2,p3,p4,p5

     -- initialize values for computation
  --  trace(1)
    y = v[1]
    z = v[2]
    -- initialize other values;  n is number of rounds
    sum = 0
    delta = #9E3779B9
    n = NROUNDS
    -- use TEA to compute output values
    while n>0 do
	p1 = shift_l(z,4,t32) 
	p2 = shift_r(z,5,t32)
	p3 = mod(xor_bits(p1,p2)+z,t32)
	p4 = mod(sum+k[and_bits(sum,3)+1],t32)
	y += xor_bits(p3,p4)
	y = mod(y,t32)
	sum += delta
	sum = mod(sum,t32)
	p1 = shift_l(y,4,t32)
	p2 = shift_r(y,5,t32)
	p3 = mod(xor_bits(p1,p2)+y,t32)
	p4 = shift_r(sum,11,t32)
	p5 = mod(sum+k[and_bits(p4,3)+1],t32)
	z += xor_bits(p3,p5)
	z = mod(z,t32)
	n -= 1
    end while
    -- trace(0)
    return {y,z}
end function

global function t_decrypt(sequence v, sequence k)
-- v asssumed to be two 32 bit unsigned numbers
-- k assumed to be four 32 bit unsigned numbers
-- will return w, sequence of two 32 bit unsigned numbers
atom sum, delta, n
atom y, z
atom p1,p2,p3,p4,p5

    y = v[1]
    z = v[2]
    -- initialize other values;  n is number of rounds
    delta = #9E3779B9
    n = NROUNDS
    sum = n * delta
    -- use TEA to compute output values
    while n>0 do
	p1 = shift_l(y,4,t32)
	p2 = shift_r(y,5,t32)
	p3 = mod(xor_bits(p1,p2)+y,t32)
	p4 = shift_r(sum,11,t32)
	p5 = mod(sum+k[and_bits(p4,3)+1],t32)
	z -= xor_bits(p3,p5)
	z = mod(z,t32)
	sum -= delta
      sum = mod(sum,t32)
	p1 = shift_l(z,4,t32) 
	p2 = shift_r(z,5,t32)
	p3 = mod(xor_bits(p1,p2)+z,t32)
	p4 = mod(sum+k[and_bits(sum,3)+1],t32)
	y -= xor_bits(p3,p4)
	y = mod(y,t32)
	n -= 1
    end while
    return {y,z}
end function




