-- TEA Tiny Encryption Algorithm
-- Direct Euphoria attempt
-- Include Library (under construction)
-- test with c-utility functions for word operations

--with trace

constant NROUNDS = 32

printf(1,"UTEA with %d rounds\n",{NROUNDS})

include wutil.e

global function t_encrypt(sequence v, sequence k)
-- v asssumed to be two 32 bit unsigned numbers
-- k assumed to be four 32 bit unsigned numbers
-- will return w, sequence of two 32 bit unsigned numbers
atom sum, delta, n
atom y, z
atom p1,p2,p3,p4,p5

     -- initialize values for computation
  --  trace(1)
    y = v[1]
    z = v[2]
    -- initialize other values;  n is number of rounds
    sum = 0
    delta = #9E3779B9
    n = NROUNDS
    -- use TEA to compute output values
    while n>0 do
	p1 = wshift(z,4)
	p2 = wshift(z,-5)
	p3 = z
	p4 = sum
	y = wadd(y,wadd(wadd(xor_bits(p1,p2),xor_bits(p3,p4)),k[(and_bits(p4,3)+1)]))
	sum = wadd(sum,delta)
	p1 = wshift(y,4)
	p2 = wshift(y,-5)
	p3 = y
	p4 = sum
	p5 = wshift(sum,-11)
	z = wadd(z,wadd(wadd(xor_bits(p1,p2),xor_bits(p3,p4)),k[(and_bits(p5,3)+1)]))
	n -= 1
    end while
    -- trace(0)
    return {y,z}
end function

global function t_decrypt(sequence v, sequence k)
-- v asssumed to be two 32 bit unsigned numbers
-- k assumed to be four 32 bit unsigned numbers
-- will return w, sequence of two 32 bit unsigned numbers
atom sum, delta, n
atom y, z
atom p1,p2,p3,p4,p5

    y = v[1]
    z = v[2]
    -- initialize other values;  n is number of rounds
    delta = #9E3779B9
    n = NROUNDS
    sum = 0
    for i = 1 to n do
      sum = wadd(sum,delta)
    end for
    -- use TEA to compute output values
    while n>0 do
	p1 = wshift(y,4)
	p2 = wshift(y,-5)
	p3 = y
	p4 = sum
	p5 = wshift(sum, -11)
	z = wsub(z,wadd(wadd(xor_bits(p1,p2),xor_bits(p3,p4)),k[(and_bits(p5,3)+1)]))
	sum = wsub(sum,delta)
	p1 = wshift(z,4)
	p2 = wshift(z,-5)
	p3 = z
	p4 = sum
	y = wsub(y,wadd(wadd(xor_bits(p1,p2),xor_bits(p3,p4)),k[(and_bits(p4,3)+1)]))
	n -= 1
    end while
    return {y,z}
end function




