-- FILE: xtea1.e
-- Interface to Tiny Encryption Algorithm, Extended Version

puts(1,"XTEA with 32 rounds\n")

include dll.e

constant dll_xtea = open_dll("xtea.dll")

constant encipher_ = define_c_proc( dll_xtea, "_encipher", {C_POINTER,C_POINTER,C_POINTER})
global procedure encipher(atom v, atom w, atom k)
    c_proc(encipher_, {v,w,k})
end procedure

constant decipher_ = define_c_proc( dll_xtea, "_decipher", {C_POINTER,C_POINTER,C_POINTER})
global procedure decipher(atom v, atom w, atom k)
    c_proc(decipher_, {v,w,k})
end procedure

include machine.e  -- for allocate

global atom tea, va, wa, ka  -- will be addresses for xtea parameters

tea = allocate(32)  -- addresses to pass to dll routines
va = tea
wa = tea+8
ka = tea+16

global function t_encrypt(sequence v, sequence k)
  poke4(va,v)
  poke4(ka,k)
  encipher(va,wa,ka)
  return peek4u({wa,2})
end function

global function t_decrypt(sequence v, sequence k)
  poke4(va,v)
  poke4(ka,k)
  decipher(va,wa,ka)
  return peek4u({wa,2})
end function

